#include	"common.h"
/* $Header: symbol.c,v 2.1 89/09/08 11:54:08 gary Locked $ */
#include	"symbol.h"
#include	"manager.h"
#define Max_Id_Chars	2000


static char *ids[Max_Vars];
static Bool id_trace[Max_Vars];
static char id_strings[Max_Id_Chars];
static char *next_char = id_strings;
static int known = 0;		       /* ids[1..known] known */
static C_Ref anon = 0;		       /* anon..-1 in use as anon vars */

void    Watch(s)
    char   *s;
{
    C_Ref   i = find_id(s);

    id_trace[i] = true;
}

void    UnWatch(s)
    char   *s;
{
    C_Ref   i = find_id(s);

    id_trace[i] = false;
}

Bool    Watched(i)
    int     i;
{
    if (0 < i && i <= known)
	return id_trace[i];
    return false;
}

char   *Id_String(i)
    int     i;
{
    if (0 < i && i <= known)
	return ids[i];
    if (0 > i)
	return "Anonymous";
    return "Bad-id (internal error)";
}


C_Ref   find_id(p)
    char   *p;
{
    int     i;

    for (i = 1; i <= known; i++) {
	if (strcmp(p, ids[i]) == 0)
	    return i;
    }
    known++;
    ids[known] = next_char;
    id_trace[known] = false;
    strcpy(ids[known], p);
    next_char += strlen(p) + 1;
    if (next_char >= id_strings + Max_Id_Chars
	|| known >= Max_Vars)
	FATAL("Too many variables");
    return known;
}

C_Ref   Mk_Var()
{
    extern C_Ref Anons;

    anon--;
    if (anon < Anons)
	Anons = anon;
    return anon;
}

void    Free_Var()
{
    anon++;
}

void    Print_Id(i)
    int     i;
{
    if (i < 0) {
	mcprintf("Anon(%d)", -i,0);
    } else {
	mcprintf("Var(%d) '%s'", i, ids[i]);
    }
}

void    Id_Dump(defined)
    Bool    defined;
{
    IPtr     p;
    int     i;
    C_Ref   indx;

    for (p = Environment, i = 0; p != Nil; p = Next(p)) {
	indx = Var_Index(Info(p));
	if (indx > 0 && (Var_Value(Info(p)) != OM) == defined) {
	    i++;
	    mcprintf("%s%c", ids[indx],
		   (i % 5 == 0 ? '\n' : '\t'));
	}
    }
    mcprintf("\n!dump complete\n",0,0);
}
